<?php
/*
 * Plugin Name: Block wp-login
 * Version: 1.2.3
 * Plugin URI: http://webd.uk/block-wp-login/
 * Description: This plugin completely blocks access to wp-login.php and creates a new secret login URL
 * Author: webd.uk
 * Author URI: http://webd.uk
 * Text Domain: block-wp-login
 */

if (!class_exists('bwpl_class')) {

	class bwpl_class {

		protected $bwpl_new_slug = '';

		function bwpl_configure_slug() {

			if (isset($_POST['bwpl_slug'])) {

				$this->bwpl_new_slug = trim(sanitize_key(wp_strip_all_tags($_POST['bwpl_slug'])));
				update_option('bwpl_ajax', trim(sanitize_key(wp_strip_all_tags($_POST['bwpl_ajax']))));
				update_option('bwpl_cron', trim(sanitize_key(wp_strip_all_tags($_POST['bwpl_cron']))));
				update_option('bwpl_xmlrpc', trim(sanitize_key(wp_strip_all_tags($_POST['bwpl_xmlrpc']))));
				update_option('bwpl_robots', trim(sanitize_key(wp_strip_all_tags($_POST['bwpl_robots']))));

				if ($this->bwpl_new_slug == '') {

					$this->bwpl_uninstall();

				} else {

					$this->bwpl_uninstall();
					$this->bwpl_install();

				}

				update_option('bwpl_slug', $this->bwpl_new_slug);
				add_filter('logout_url', array($this, 'bwpl_change_logout_url'));
				add_filter('lostpassword_url', array($this, 'bwpl_change_logout_url'));
				// add_filter('login_url', array($this, 'bwpl_change_logout_url'));

			}

			add_settings_section('bwpl', __('Block wp-login', 'block-wp-login'), array($this, 'bwpl_settings_title'), 'permalink');
			add_settings_field('bwpl_slug', __('Login address', 'block-wp-login'), array($this, 'bwpl_settings_html'), 'permalink', 'bwpl', array('label_for' => 'bwpl_slug'));
			register_setting('permalink', 'bwpl_slug', 'strval');

		}

		function bwpl_settings_title() {

			?>
			<p><?php _e('Use the options below to completely block access to wp-login.php and create a new secret login address.', 'block-wp-login'); ?></p>
			<?php

		}

		function bwpl_settings_html() {

        	if (isset($_GET['activate']) && $_GET['activate'] == 'true') {
        		$this->bwpl_activate();
        	}


			if (get_option('bwpl_purchased') == true) {

				?>
				<input id="bwpl_slug" name="bwpl_slug" type="text" class="regular-text code" value="<?php echo get_option('bwpl_slug'); ?>" onkeydown="if (this.value != '') { document.getElementById('bwpl_ajax').disabled=false; document.getElementById('bwpl_cron').disabled=false; document.getElementById('bwpl_xmlrpc').disabled=false; document.getElementById('bwpl_robots').disabled=false; } else { document.getElementById('bwpl_ajax').disabled=true; document.getElementById('bwpl_cron').disabled=true; document.getElementById('bwpl_xmlrpc').disabled=true; document.getElementById('bwpl_robots').disabled=true; }" /> <a href="http://webd.uk/block-wp-login/#wp-login" class="dashicons-before dashicons-editor-help" style="text-decoration: none;"></a>
				<?php

			} else {

				if (get_option('bwpl_slug') == '') {

					$characters = 'abcdefghijklmnopqrstuvwxyz';
					$randomString = '';
					for ($i = 0; $i < 8; $i++) {
						$randomString .= $characters[rand(0, strlen($characters) - 1)];
					}

				} else {

					$randomString = get_option('bwpl_slug');

				}

?>

				<input type="hidden" name="bwpl_slug" value="" /><input id="bwpl_slug" name="bwpl_slug" type="checkbox" value="<?php echo $randomString; ?>"<?php if (get_option('bwpl_slug') != '') { echo(' checked'); } ?> onchange="if (this.checked) { if (!confirm('<?php _e('WARNING! DO NOT LOCK YOURSELF OUT! Your new login address will be', 'block-wp-login'); ?> <?php echo get_site_url(null, ($randomString . '/')); ?>')) { this.checked = false; } } if (this.checked) { document.getElementById('bwpl_ajax').disabled=false; document.getElementById('bwpl_cron').disabled=false; document.getElementById('bwpl_xmlrpc').disabled=false; document.getElementById('bwpl_robots').disabled=false; } else { document.getElementById('bwpl_ajax').disabled=true; document.getElementById('bwpl_ajax').checked=false; document.getElementById('bwpl_cron').disabled=true; document.getElementById('bwpl_cron').checked=false; document.getElementById('bwpl_xmlrpc').disabled=true; document.getElementById('bwpl_xmlrpc').checked=false; document.getElementById('bwpl_robots').disabled=true; document.getElementById('bwpl_robots').checked=false; }" /> <a href="http://webd.uk/block-wp-login/#wp-login" class="dashicons-before dashicons-editor-help" style="text-decoration: none;"></a>

				<p><a href="https://www.paypal.com/cgi-bin/webscr?cmd=_xclick&business=info@domainsupport.co.uk&item_name=Block+wp-login+for+<?php echo (isset($_SERVER['HTTPS']) ? "https" : "http") . "://$_SERVER[HTTP_HOST]"; ?>&amount=10%2E00&currency_code=GBP" title="<?php _e('Upgrade Block wp-login', 'block-wp-login'); ?>"><?php _e('Upgrade now for &pound;10 to choose your own login address', 'block-wp-login'); ?></a>.</p>

                <p><a href="?activate=true" title="<?php _e('Activate Block wp-login', 'block-wp-login'); ?>"><?php _e('Activate your WP Accounts Upgrade', 'block-wp-login'); ?></a>.</p>

<?php

			}

				?>
				<p><strong><?php _e('Upgrade Status', 'block-wp-login'); ?>:</strong> <?php if (get_option('bwpl_purchased') == true) { _e('Upgraded', 'block-wp-login'); } else { _e('Not Upgraded', 'block-wp-login'); } ?><br />
                <strong><?php _e('Current Login URL', 'block-wp-login'); ?>:</strong> <?php
				if (get_option('bwpl_slug') == '') {
					echo get_site_url(null, 'wp-login.php');
				} else {
					echo get_site_url(null, (get_option('bwpl_slug') . '/'));
				} ?></p>
				<p><input type="hidden" name="bwpl_ajax" value="" /><input id="bwpl_ajax" name="bwpl_ajax" type="checkbox" value="true"<?php if (get_option('bwpl_ajax') != '') { echo(' checked'); } ?><?php if (get_option('bwpl_slug') == '') { echo(' disabled'); } ?> /> <?php _e('Block admin-ajax.php (except from /wp-admin/)', 'block-wp-login'); ?> <a href="http://webd.uk/block-wp-login/#admin-ajax" class="dashicons-before dashicons-editor-help" style="text-decoration: none;"></a><br />
				<input type="hidden" name="bwpl_cron" value="" /><input id="bwpl_cron" name="bwpl_cron" type="checkbox" value="true"<?php if (get_option('bwpl_cron') != '') { echo(' checked'); } ?> onchange="if (this.checked) { if (!confirm('<?php _e('WARNING! Blocking wp-cron.php will stop posting of scheduled posts as well other Wordpress core features.', 'block-wp-login'); ?>')) { this.checked = false; } }"<?php if (get_option('bwpl_slug') == '') { echo(' disabled'); } ?> /> <?php _e('Block wp-cron.php', 'block-wp-login'); ?> <a href="http://webd.uk/block-wp-login/#wp-cron" class="dashicons-before dashicons-editor-help" style="text-decoration: none;"></a><br />
				<input type="hidden" name="bwpl_xmlrpc" value="" /><input id="bwpl_xmlrpc" name="bwpl_xmlrpc" type="checkbox" value="true"<?php if (get_option('bwpl_xmlrpc') != '') { echo(' checked'); } ?> onchange="if (this.checked) { if (!confirm('<?php _e('WARNING! Blocking xmlrpc.php will stop posting by remote clients as well other features.', 'block-wp-login'); ?>')) { this.checked = false; } }"<?php if (get_option('bwpl_slug') == '') { echo(' disabled'); } ?> /> <?php _e('Block xmlrpc.php', 'block-wp-login'); ?> <a href="http://webd.uk/block-wp-login/#xmlrpc" class="dashicons-before dashicons-editor-help" style="text-decoration: none;"></a><br />
				<input type="hidden" name="bwpl_robots" value="" /><input id="bwpl_robots" name="bwpl_robots" type="checkbox" value="true"<?php if (get_option('bwpl_robots') != '') { echo(' checked'); } ?><?php if (get_option('bwpl_slug') == '') { echo(' disabled'); } ?> /> <?php _e('Block robots.txt', 'block-wp-login'); ?> <a href="http://webd.uk/block-wp-login/#robots" class="dashicons-before dashicons-editor-help" style="text-decoration: none;"></a></p>
				<?php

		}

		function bwpl_activate() {

                $http_url = 'http://webd.uk/block-wp-login-activate/';
                $http_args = array(
                    'timeout' => 15,
                    'body' => array(
                        'url' => ((isset($_SERVER['HTTPS']) ? "https" : "http") . '://' . $_SERVER['HTTP_HOST'])
                    )
                );
                $request = wp_remote_post( $http_url, $http_args );

				if (isset($request['body']) && $request['body'] == 'True') {

					update_option('bwpl_purchased', true);

				} else {

					delete_option('bwpl_purchased');

				}

		}

		function bwpl_send_emails($new_version) {

			$blogusers = get_users('role=Administrator');
			$admin_emails = array();

			foreach ($blogusers as $user) {
				if ($user->user_email != '') {
					$this->bwpl_send_email($user->user_email, $new_version);
					array_push($admin_emails, $user->user_email);
				}
			}

			if (get_bloginfo('admin_email') != "" && !in_array(get_bloginfo('admin_email'),$admin_emails)) {
				$this->bwpl_send_email(get_bloginfo('admin_email'), $new_version);
			}

		}

		function bwpl_install($new_version = false) {

			$this->bwpl_send_emails($new_version);

			if (file_exists($this->get_home_path() . 'wp-login.php')) {

				$content = file_get_contents($this->get_home_path() . 'wp-login.php');
				$content_chunks = explode('wp-login.php', $content);
				$content = implode($this->bwpl_new_slug . '-wp-login.php', $content_chunks);

				if ((!file_exists($this->get_home_path() . $this->bwpl_new_slug . '-wp-login.php') && is_writable($this->get_home_path())) || is_writable($this->get_home_path() . $this->bwpl_new_slug . '-wp-login.php')) {

					file_put_contents($this->get_home_path() . $this->bwpl_new_slug . '-wp-login.php', $content);

				}

			}

			if ((!file_exists($this->get_home_path() . '.htaccess') && is_writable($this->get_home_path())) || is_writable($this->get_home_path() . '.htaccess')) {

				$markerdata = explode("\n", implode('', file($this->get_home_path() . '.htaccess')));
				$found = false;
				$newdata = '';

				foreach ($markerdata as $line) {

					if (!$found) {

						$newdata .= "# BEGIN BlockWPLogin\n";
						$newdata .= "<IfModule mod_rewrite.c>\n";
						$newdata .= "RewriteEngine On\n";
						$newdata .= "RewriteRule ^".substr($this->bwpl_home_root(), 1)."wp-login.php - [F]\n";

						if (get_option('bwpl_ajax') == 'true') {

							$newdata .= 'RewriteCond %{HTTP_REFERER} !^' . str_replace('.', '\.', get_site_url(null, 'wp-admin/')) . " [NC]\n";
							$newdata .= "RewriteRule ^" . substr($this->bwpl_home_root(), 1) . "wp-admin/admin-ajax.php - [F]\n";

						}

						if (get_option('bwpl_cron') == 'true') { $newdata .= "RewriteRule ^".substr($this->bwpl_home_root(), 1)."wp-cron.php - [F]\n"; }
						if (get_option('bwpl_xmlrpc') == 'true') { $newdata .= "RewriteRule ^".substr($this->bwpl_home_root(), 1)."xmlrpc.php - [F]\n"; }
						if (get_option('bwpl_robots') == 'true') { $newdata .= "RewriteRule ^robots.txt - [F]\n"; }
						$newdata .= "RewriteRule ^$this->bwpl_new_slug/?$ ".$this->bwpl_home_root()."$this->bwpl_new_slug-wp-login.php [QSA,L]\n";
						$newdata .= "</IfModule>\n";
						$newdata .= "# END BlockWPLogin\n\n";
						$newdata .= "$line\n";
						$found = true;

					} else {

						$newdata .= "$line\n";

					}

				}

				$f = @fopen($this->get_home_path() . '.htaccess', 'w');
				fwrite($f, $newdata);

			}

			update_option('bwpl_wp_version', get_bloginfo('version'));

		}

		function bwpl_admin_notice_html() {

			?>
			<div class="notice notice-success">
			<p><strong><?php _e('Block wp-login', 'block-wp-login'); ?></strong> <?php _e('activated.', 'block-wp-login'); ?> <a href="<?php echo($this->bwpl_home_root()); ?>wp-admin/options-permalink.php"><?php _e('Configure the plugin here', 'block-wp-login'); ?></a>.</p>
			</div>
			<?php

		}

		function bwpl_uninstall() {

			if (is_writable($this->get_home_path() . '.htaccess')) {

				$markerdata = explode("\n", implode('', file($this->get_home_path() . '.htaccess')));
				$found = false;
				$blank_line = false;
				$newdata = '';

				foreach ($markerdata as $line) {

						if ($blank_line == true && $line == '') {

							$found = true;

						}

						if ($blank_line == true && $line != '') {

							$found = false;

						}

						if ($line != '') {

							$blank_line = false;

						} else {

							$blank_line = true;

						}

						if ($line == '# BEGIN BlockWPLogin') {

							$found = true;

						}

						if (!$found) {

							$newdata .= "$line\n";

						}

						if ($line == '# END BlockWPLogin') {

							$found = false;

						}

				}

				$f = @fopen($this->get_home_path() . '.htaccess', 'w');
				fwrite($f, $newdata);

			}

			add_filter('logout_url', array($this, 'bwpl_reset_logout_url'));
			add_filter('lostpassword_url', array($this, 'bwpl_reset_logout_url'));
			// add_filter('login_url', array($this, 'bwpl_reset_logout_url'));

			if (is_writable($this->get_home_path() . get_option('bwpl_slug') . '-wp-login.php') && get_option('bwpl_slug') != '') {

				unlink($this->get_home_path() . get_option('bwpl_slug') . '-wp-login.php');

			}

			update_option('bwpl_slug', '');

		}

		/**
		 * Get the absolute filesystem path to the root of the WordPress installation
		 *
		 * @since 1.5.0
		 *
		 * @return string Full filesystem path to the root of the WordPress installation
		 */
		function get_home_path() {
			$home    = set_url_scheme( get_option( 'home' ), 'http' );
			$siteurl = set_url_scheme( get_option( 'siteurl' ), 'http' );
			if ( ! empty( $home ) && 0 !== strcasecmp( $home, $siteurl ) ) {
				$wp_path_rel_to_home = str_ireplace( $home, '', $siteurl ); /* $siteurl - $home */
				$pos = strripos( str_replace( '\\', '/', $_SERVER['SCRIPT_FILENAME'] ), trailingslashit( $wp_path_rel_to_home ) );
				$home_path = substr( $_SERVER['SCRIPT_FILENAME'], 0, $pos );
				$home_path = trailingslashit( $home_path );
			} else {
				$home_path = ABSPATH;
			}

			return str_replace( '\\', '/', $home_path );
		}

		function bwpl_change_logout_url( $login_url ) {

			$url = str_replace( 'wp-login', get_option('bwpl_slug') . '-wp-login', $login_url );
			return $url;

		}

		function bwpl_reset_logout_url( $login_url ) {

			$url = str_replace( get_option('bwpl_slug') . '-wp-login', 'wp-login', $login_url );
			return $url;

		}

		function bwpl_load_plugin_textdomain() {
		    load_plugin_textdomain('block-wp-login', FALSE, basename( dirname( __FILE__ ) ) . '/languages/' );
		}

		function filter_plugin_actions($links) {

			$settings_link = '<a href="' . $this->bwpl_home_root() . 'wp-admin/options-permalink.php">' . __('Settings', 'block-wp-login') . '</a>';
			array_unshift( $links, $settings_link );
			return $links;

		}

		function bwpl_send_email($recipient, $new_version) {

            if ($new_version == false) {

    			$message = __('Your Wordpress login URL has been changed:', 'block-wp-login') . "\r\n\r\n";

            } else {

			    $message = __('A new version of Wordpress has been detected so we have reinstalled "Block wp-login" and here is a reminder of your login URL:', 'block-wp-login') . "\r\n\r\n";

            }

			$message .= get_site_url(null, ($this->bwpl_new_slug . '/')) . "\r\n\r\n";
			$message .= __('Make sure you save this email and / or bookmark this address so you don\'t get locked out!', 'block-wp-login') . "\r\n\r\n";
			$message .= __('Contact us if you are having trouble with Wordpress http://webd.uk', 'block-wp-login') . "\r\n\r\n";
			$message .= __('If you like our plugin please give it a good review on https://wordpress.org/support/plugin/block-wp-login/reviews/', 'block-wp-login') . "\r\n\r\n";

			if ( is_multisite() ) {

				$blogname = get_network()->site_name;

			} else {

				$blogname = wp_specialchars_decode(get_option('blogname'), ENT_QUOTES);

			}

            if ($new_version == false) {

		    	$title = sprintf( __('[%s] Wordpress Login Changed', 'block-wp-login'), $blogname );

            } else {

		    	$title = sprintf( __('[%s] Wordpress Login Reminder', 'block-wp-login'), $blogname );

            }

			if (!wp_mail($recipient, wp_specialchars_decode($title), $message)) {

				add_action('admin_notices', array($this, 'bwpl_admin_notice_email_html'));

			}

		}

		function bwpl_admin_notice_email_html() {

			?>
			<div class="notice notice-error">
			<p><strong><?php _e('Block wp-login', 'block-wp-login'); ?></strong> <?php _e('activated email could not be sent', 'block-wp-login'); ?>.</p>
			</div>
			<?php

		}

		function bwpl_home_root() {

			$home_root = parse_url(home_url());

			if (isset($home_root['path'])) {

				$home_root = trailingslashit($home_root['path']);

			} else {

				$home_root = '/';

			}

			return $home_root;

		}

		function bwpl_new_wordpress_version() {

			$bwpl_old_slug = get_option('bwpl_slug');
			$this->bwpl_uninstall();
			$this->bwpl_new_slug = $bwpl_old_slug;
			$this->bwpl_install(true);
			update_option('bwpl_slug', $bwpl_old_slug);

		}

	}

	$Block_wp_login = new bwpl_class();

	add_action('plugins_loaded', array($Block_wp_login, 'bwpl_load_plugin_textdomain'));

	add_filter('plugin_action_links_' . plugin_basename(__FILE__), array($Block_wp_login, 'filter_plugin_actions'));

	add_action('admin_init', array($Block_wp_login, 'bwpl_configure_slug'));

	register_deactivation_hook(__FILE__, array($Block_wp_login, 'bwpl_uninstall'));

	if (get_option('bwpl_slug') != '') {

		if (get_option('bwpl_wp_version') != get_bloginfo('version')) {

			add_action('admin_init', array($Block_wp_login, 'bwpl_new_wordpress_version'));

		}

		add_filter('logout_url', array($Block_wp_login, 'bwpl_change_logout_url'));
		add_filter('lostpassword_url', array($Block_wp_login, 'bwpl_change_logout_url'));
		// add_filter('login_url', array($Block_wp_login, 'bwpl_change_logout_url'));

	} else {

		add_action('admin_notices', array($Block_wp_login, 'bwpl_admin_notice_html'));

	}

}

?>
